"""Add support for workflow credentials and workflow modes

Revision ID: 61070219989b
Revises: b88e083455d3
Create Date: 2023-08-08 15:34:32.905772

"""

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "61070219989b"
down_revision = "b88e083455d3"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "workflow_mode",
        sa.Column("mode_id", sa.BINARY(length=16), nullable=False),
        sa.Column("schema_path", sa.String(length=256), nullable=False),
        sa.Column("entrypoint", sa.String(length=256), nullable=False),
        sa.Column("name", sa.String(length=128), nullable=False),
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column(
            "updated_at",
            sa.Integer(),
            server_default=sa.text("(UNIX_TIMESTAMP())"),
            nullable=False,
        ),
        sa.PrimaryKeyConstraint("mode_id"),
    )
    op.create_index(op.f("ix_workflow_mode_mode_id"), "workflow_mode", ["mode_id"], unique=True)
    op.create_table(
        "workflow_modus_to_version_mapping",
        sa.Column("workflow_version_commit_hash", sa.String(length=40), nullable=False),
        sa.Column("workflow_mode_id", sa.BINARY(length=16), nullable=False),
        sa.ForeignKeyConstraint(["workflow_mode_id"], ["workflow_mode.mode_id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(
            ["workflow_version_commit_hash"], ["workflow_version.git_commit_hash"], ondelete="CASCADE"
        ),
        sa.PrimaryKeyConstraint("workflow_version_commit_hash", "workflow_mode_id"),
    )
    op.add_column("workflow", sa.Column("credentials_username", sa.String(length=128), nullable=True))
    op.add_column("workflow", sa.Column("credentials_token", sa.String(length=128), nullable=True))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("workflow", "credentials_token")
    op.drop_column("workflow", "credentials_username")
    op.drop_table("workflow_modus_to_version_mapping")
    op.drop_index(op.f("ix_workflow_mode_mode_id"), table_name="workflow_mode")
    op.drop_table("workflow_mode")
    # ### end Alembic commands ###
